#ifndef __FACE3D_H__
#define __FACE3D_H__

#include<stdio.h>
#include"material3d.h"
#include"vector3d.h"

class Face3D {
  public:
    Vector3D *P0, *P1, *P2;
    Vector3D N0, N1, N2;
    Vector3D planeeq;
    Vector3D normal;
    Material3D *material;
    int drawlevel;
  
      // Constructoras
    Face3D(Vector3D *p0, Vector3D *p1, Vector3D *p2, Vector3D n0, Vector3D n1, Vector3D n2, Material3D *m, int dl) : P0(p0), P1(p1), P2(p2), N0(n0), N1(n1), N2(n2), material(m), drawlevel(dl) { }
    Face3D(Vector3D *p0, Vector3D *p1, Vector3D *p2, Vector3D n, Material3D *m, int dl) : P0(p0), P1(p1), P2(p2), N0(n), N1(n), N2(n), material(m), drawlevel(dl) { }
    Face3D(Vector3D *p0, Vector3D *p1, Vector3D *p2, Material3D *m, int dl) : P0(p0), P1(p1), P2(p2), material(m), drawlevel(dl) { }
    Face3D(Vector3D *p0, Vector3D *p1, Vector3D *p2, int dl) : P0(p0), P1(p1), P2(p2), drawlevel(dl) { material = NULL; }
    Face3D(int drawlevel);
    Face3D();

      // Calculos curiosos
    Vector3D CalculateNormal() throw(int);
    Vector3D CalculatePlaneEq(void) throw(int);
    
      // Debugging
    void print(void);
    
      // Cargar/salvar caras
    void save(FILE *f, int nvertex, Vector3D **vertexlist, int nmat, Material3D **matlist);
    void load(FILE *f, Vector3D **vertexlist, Material3D **matlist);
};

#endif
