#ifndef __VECTOR3D_H__
#define __VECTOR3D_H__

#include<stdio.h>
#include<iostream>

class Vector3D {
  public:
    float vector[4];
    double dvector[4];
    
      // Constructoras
    Vector3D(float x, float y, float z, float w);
    Vector3D(float x, float y, float z);
    Vector3D(float x, float y);
    Vector3D();
    
      // Consulta
    float X();
    float Y();
    float Z();
    float W();

      // Modificacion
    float X(float x);
    float Y(float y);
    float Z(float z);
    float W(float w);
    void set(float x, float y, float z);
    void set(float x, float y, float z, float w);
    void set(Vector3D v);
    void refreshd(void);
    
      // Operaciones especiales para construir bounding boxes
    void BoundingMin(Vector3D a);
    void BoundingMax(Vector3D a);
    
      // Operaciones sobre vectores
    Vector3D operator +  (Vector3D &a); // Suma de vectores
    Vector3D operator += (Vector3D &a); // Suma de vectores
    Vector3D operator -  (Vector3D &a); // Resta de vectores
    Vector3D operator ^  (Vector3D &b); // Producto vectorial
    float    operator *  (Vector3D &b); // Producto escalar
    Vector3D operator *  (float a);     // Multiplicacion por escalar
    Vector3D operator /  (float a);     // Division por escalar
    bool     operator == (Vector3D &a); // Comparacion
    void normalize(void) throw(int);
    float modulus(void);

      // Debug
    void print(void);
    void println(void);
    void printd(void);
    void printdln(void);
    
      // Saving/Load
    void save(FILE *f);
    void load(FILE *f);
};

#endif
